=== debian/changelog ===
vlfeat (0.9.17+dfsg0-6build1) trusty; urgency=medium

  * Rebuild for octave 3.8.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Feb 2014 23:50:55 +0000

vlfeat (0.9.17+dfsg0-6) unstable; urgency=low

  * Bug fix: "Do not compress the example *.m files", thanks to Rafael
    Laboissiere (Closes: #734049).

 -- Dima Kogan <dima@secretsauce.net>  Sun, 12 Jan 2014 01:56:11 -0800

vlfeat (0.9.17+dfsg0-5) unstable; urgency=low

  * vlfeat is now Multi-arch:same

 -- Dima Kogan <dima@secretsauce.net>  Sat, 28 Dec 2013 00:15:39 -0800

vlfeat (0.9.17+dfsg0-4) unstable; urgency=low

  * Build fixes to work on a wider array of machines:

    - No longer using SSE or AVX, since the target may not have those
    - No longer building x86-specific code on non-x86 boxes

 -- Dima Kogan <dima@secretsauce.net>  Mon, 23 Dec 2013 13:35:09 -0800

vlfeat (0.9.17+dfsg0-3) unstable; urgency=low

  * libvlfeat-doc no longer ships intermediate build files

 -- Dima Kogan <dima@secretsauce.net>  Sun, 22 Dec 2013 21:02:49 -0800

vlfeat (0.9.17+dfsg0-2) unstable; urgency=low

  * Stripped Google Adsense and Google custom search from the packaged
    docs

 -- Dima Kogan <dima@secretsauce.net>  Sun, 22 Dec 2013 12:54:16 -0800

vlfeat (0.9.17+dfsg0-1) unstable; urgency=low

  * Initial Debian release (Closes: #576124)

 -- Dima Kogan <dima@secretsauce.net>  Wed, 06 Nov 2013 22:55:35 -0800
