=== debian/control ===
Source: vlfeat
Section: science
Priority: optional
Build-Depends: debhelper (>= 9), dh-exec, liboctave-dev, octave-pkg-dev (>= 1.0.0),
               transfig, ghostscript, inkscape, texlive-latex-base, imagemagick,
               python2.7, doxygen, rsync
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dima@secretsauce.net>
Standards-Version: 3.9.4
Homepage: http://www.vlfeat.org
Vcs-Git: git://anonscm.debian.org/debian-science/packages/vlfeat.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/vlfeat.git

Package: libvlfeat0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including SIFT, MSER,
 k-means, hierarchical k-means, agglomerative information bottleneck, and quick
 shift. It is written in C for efficiency and compatibility, with interfaces in
 GNU octave for ease of use, and detailed documentation throughout

Package: libvlfeat-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, libvlfeat0 (= ${binary:Version})
Recommends: libvlfeat-doc
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including SIFT, MSER,
 k-means, hierarchical k-means, agglomerative information bottleneck, and quick
 shift. It is written in C for efficiency and compatibility, with interfaces in
 GNU octave for ease of use, and detailed documentation throughout
 .
 Development files

Package: libvlfeat0-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libvlfeat0 (= ${binary:Version})
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including SIFT, MSER,
 k-means, hierarchical k-means, agglomerative information bottleneck, and quick
 shift. It is written in C for efficiency and compatibility, with interfaces in
 GNU octave for ease of use, and detailed documentation throughout
 .
 Debug symbols

Package: libvlfeat-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including SIFT, MSER,
 k-means, hierarchical k-means, agglomerative information bottleneck, and quick
 shift. It is written in C for efficiency and compatibility, with interfaces in
 GNU octave for ease of use, and detailed documentation throughout
 .
 Documentation

Package: octave-vlfeat
Section: libs
Priority: extra
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libvlfeat0 (>= ${binary:Version}),
         ${octave:Depends}
Recommends: libvlfeat-doc
Description: Computer vision library focussing on visual features and clustering
 VLFeat implements popular computer vision algorithms including SIFT, MSER,
 k-means, hierarchical k-means, agglomerative information bottleneck, and quick
 shift. It is written in C for efficiency and compatibility, with interfaces in
 GNU octave for ease of use, and detailed documentation throughout
 .
 GNU Octave interface
