=== debian/changelog ===
vlfeat (0.9.20+dfsg0-2) unstable; urgency=medium

  * Team upload.
  * Build-depend on dh-octave instead of octave-pkg-dev.
    Thanks to Rafael Laboissière (Closes: #890085)
  * Update Vcs-* fields for salsa.
  * Bump packages from priority extra to optional.
  * Also missing files to clean rule: *.o, VERSION, toolbox/{mex,noprefix}.

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 13 Feb 2018 12:48:31 +0100

vlfeat (0.9.20+dfsg0-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dima@secretsauce.net>  Mon, 31 Aug 2015 00:05:46 -0700

vlfeat (0.9.19+dfsg0-1) experimental; urgency=medium

  [ Dima Kogan ]
  * New upstream release
  * Handling new target path behavior of mkoctfile. (Closes: #756222)

  [ Anton Gladky ]
  * Removed mathjax from the docs.
  * Replace BSD by BSD-2-clause in d/copyright.
  * Set Standards-Version: 3.9.6. No changes.

 -- Dima Kogan <dima@secretsauce.net>  Thu, 16 Oct 2014 14:38:32 -0700
