=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: vlfeat
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9), dh-exec, liboctave-dev, octave-pkg-dev (>= 1.0.0),
-               transfig, ghostscript, inkscape, texlive-latex-base, imagemagick,
-               python2.7, doxygen, rsync
+Build-Depends: debhelper (>= 9), dh-exec, liboctave-dev, dh-octave,
+               transfig, ghostscript, librsvg2-bin, texlive-latex-base, imagemagick,
+               python2.7, doxygen, rsync, groff
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Dima Kogan <dima@secretsauce.net>
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Homepage: http://www.vlfeat.org
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/vlfeat.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/vlfeat.git
+Vcs-Git: https://salsa.debian.org/science-team/vlfeat.git
+Vcs-Browser: https://salsa.debian.org/science-team/vlfeat
 
-Package: libvlfeat0
+Package: libvlfeat1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -28,7 +28,7 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends}, libvlfeat0 (= ${binary:Version})
+Depends: ${misc:Depends}, libvlfeat1 (= ${binary:Version})
 Recommends: libvlfeat-doc
 Description: Computer vision library focussing on visual features and clustering
  VLFeat implements popular computer vision algorithms including SIFT, MSER,
@@ -38,12 +38,11 @@
  .
  Development files
 
-Package: libvlfeat0-dbg
+Package: libvlfeat1-dbg
 Section: debug
-Priority: extra
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libvlfeat0 (= ${binary:Version})
+Depends: ${misc:Depends}, libvlfeat1 (= ${binary:Version})
 Description: Computer vision library focussing on visual features and clustering
  VLFeat implements popular computer vision algorithms including SIFT, MSER,
  k-means, hierarchical k-means, agglomerative information bottleneck, and quick
@@ -66,11 +65,10 @@
 
 Package: octave-vlfeat
 Section: libs
-Priority: extra
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libvlfeat0 (>= ${binary:Version}),
+Depends: ${shlibs:Depends}, ${misc:Depends}, libvlfeat1 (>= ${binary:Version}),
          ${octave:Depends}
 Recommends: libvlfeat-doc
 Description: Computer vision library focussing on visual features and clustering
