=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,7 @@
 	dh $@
 
 override_dh_auto_build:
-	make MKOCTFILE=`which mkoctfile` VERB=1 CFLAGS+=-g all doc
+	make PYTHON=python2.7 MKOCTFILE=`which mkoctfile` VERB=1 CFLAGS+=-g all doc
 
 
 override_dh_auto_install: $(addprefix install/,data $(wildcard toolbox/*))
@@ -20,18 +20,19 @@
 	ln -fs libvl.so.$(VERSION) libvl.so.$(API_VERSION)
 
 override_dh_gencontrol:
-	dh_gencontrol -- -V"octave:Depends=octave(>=`octave-config --print VERSION`)"
+	dh_octave_substvar
+	dh_gencontrol
 
 override_dh_strip: strip_mex
-	dh_strip --dbg-package=libvlfeat0-dbg
+	dh_strip --dbg-package=libvlfeat$(API_VERSION)-dbg
 
 override_dh_installdocs:
 	dh_installdocs -Xbuild/
 
 override_dh_auto_clean:
 	dh_auto_clean
-	rm -f libvl.so*
-
+	rm -f VERSION libvl.so* *.o
+	rm -rf toolbox/noprefix/ toolbox/mex/
