=== debian/changelog ===
vlfeat (0.9.21+dfsg0-7build1) jammy; urgency=medium

  * No-change rebuild against octave 6.4.0

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 19 Jan 2022 09:39:05 +0000

vlfeat (0.9.21+dfsg0-7) unstable; urgency=medium

  * Fixed build error (Closes: #991066). Thanks to Dennis Filder
    <d.filder@web.de> for the patch
  * Fixed debian/watch

 -- Dima Kogan <dkogan@debian.org>  Thu, 11 Nov 2021 10:27:08 -0800

vlfeat (0.9.21+dfsg0-6) unstable; urgency=medium

  * Team upload.
  * Source-only upload following trip through NEW.

 -- Stuart Prescott <stuart@debian.org>  Sat, 08 Feb 2020 16:39:32 +1100

vlfeat (0.9.21+dfsg0-5) unstable; urgency=medium

  * Team upload.
  * Build-depend on Python 3 instead of Python 2 (Closes: #938791).
    - use 2to3 to update documentatation producing code
    - fix whitespace in Python code
    - fix bytes/str handling in XML processing
  * Build-depend on pygments for syntax highlighting of source code
    in documentation.

 -- Stuart Prescott <stuart@debian.org>  Tue, 21 Jan 2020 23:34:20 +1100

vlfeat (0.9.21+dfsg0-4) unstable; urgency=medium

  * Fixed build with gcc-9 (Closes: #925853)

 -- Dima Kogan <dkogan@debian.org>  Thu, 12 Dec 2019 22:36:05 -0800

vlfeat (0.9.21+dfsg0-3) unstable; urgency=medium

  * Added forgotten Breaks tag (Closes: #901208)

 -- Dima Kogan <dkogan@debian.org>  Mon, 13 Aug 2018 23:05:31 -0700

vlfeat (0.9.21+dfsg0-2) unstable; urgency=medium

  * Added forgotten Replaces tag (Closes: #892047)
  * Fixed FTBFS failures on non-x86 architectures, thanks to Adrian Bunk
    (Closes: #892107).

 -- Dima Kogan <dkogan@debian.org>  Fri, 06 Apr 2018 21:41:15 -0700

vlfeat (0.9.21+dfsg0-1) unstable; urgency=medium

  * New upstream release
  * Added a note highlighting removal of patented code (Closes: #816397)

 -- Dima Kogan <dkogan@debian.org>  Fri, 02 Mar 2018 23:23:30 -0800
