=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,8 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
+
+export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow
+
 
 # grab the version from the debian changelog
 VERSION := $(shell sed -n 's/.*(\([0-9\.]*[0-9]\).*).*/\1/;; p; q;' debian/changelog)
@@ -7,12 +10,16 @@
 # grab the API version from the library SONAME
 API_VERSION = $(shell objdump -p bin/*/libvl.so | perl -ne 'if(/^\s+SONAME\s+libvl.so./p) {print $${^POSTMATCH}; exit;}')
 
+IMAGEMAGICK_POLICY := /etc/$(shell convert -version|sed -n '/^Version: /s@Version: ImageMagick \([[:digit:]]\+\)\..*@ImageMagick-\1@p')/policy.xml
+
 %:
 	dh $@
 
 override_dh_auto_build:
-	make PYTHON=python2.7 MKOCTFILE=`which mkoctfile` VERB=1 CFLAGS+=-g all doc
-
+	mkdir -p debian/tmp/ImageMagick
+	sed -e '/<policy domain="coder" rights="none" pattern="PDF" .>/s@"none"@"read|write"@' "$(IMAGEMAGICK_POLICY)" > debian/tmp/ImageMagick/policy.xml
+	make XDG_CONFIG_HOME="$(shell pwd)/debian/tmp" PYTHON=python3 MKOCTFILE=`which mkoctfile` VERB=1 CFLAGS+=-g all doc
+	rm -Rf debian/tmp/ImageMagick
 
 override_dh_auto_install: $(addprefix install/,data $(wildcard toolbox/*))
 	cp bin/*/libvl.so libvl.so.$(VERSION)
@@ -24,7 +31,7 @@
 	dh_gencontrol
 
 override_dh_strip: strip_mex
-	dh_strip --dbg-package=libvlfeat$(API_VERSION)-dbg
+	dh_strip --dbgsym-migration='libvlfeat$(API_VERSION)-dbg (<< 0.9.21+dfsg0-1~)'
 
 override_dh_installdocs:
 	dh_installdocs -Xbuild/
@@ -43,7 +50,7 @@
 include /usr/share/octave/debian/defs.make
 
 
-# I want to take all the *.m in toolbox/xxx/ for all xxx except mex and
+# I want to take all the *.m in toolbox/xxx/ for all xxx except mex and doc and
 # noprefix. I want to take only some particular toolbox/*.m. There are many
 # other files strewn around that I want to ignore. This is somewhat
 # convoluted...
@@ -72,7 +79,7 @@
 override_dh_compress:
 	dh_compress -X.m
 
-$(filter-out %.m install/data install/toolbox/mex install/toolbox/noprefix,$(OCTAVE_PHONY_TARGETS)):
+$(filter-out %.m install/data install/toolbox/mex install/toolbox/doc install/toolbox/noprefix,$(OCTAVE_PHONY_TARGETS)):
 	if [ -d $(OCT_TARGET) ]; then							\
 		install -d $(OCTAVE_MPATH);						\
 		install -d $(OCTAVE_MPATH)/$(notdir $(OCT_TARGET));			\
