=== debian/watch ===
version=4
opts=dversionmangle=s/(?:\+dfsg|\+repack).*$//,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/vlfeat-$1\.tar\.gz/ \
  https://github.com/vlfeat/vlfeat/tags .*/v?(\d\S+)\.tar\.gz
